#!/usr/bin/env python

#^#
# OVSConfig.py
#
# <description>
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from ConfigParser import ConfigParser
from os import makedirs
from os.path import dirname, join, isfile, isdir
from OVSConstants import CONFIG_DIR
from shutil import copyfile

_g_config = None

def init_config():
    #make default dirs
    dbdir = join(CONFIG_DIR, "db")
    if not isdir(dbdir): makedirs(dbdir)
    certdir = join(CONFIG_DIR, "cert")
    if not isdir(certdir): makedirs(certdir)

    #agent configuration file
    filename = join(CONFIG_DIR, "agent.ini")
    filename_default = join(dirname(__file__), "conf/agent.ini.default")
    if not isfile(filename):
        if isfile(filename_default):
	    copyfile(filename_default, filename)
        else:
	    raise Exception("Error: config file '%s' does not exist." % filename)

    global _g_config 
    _g_config = ConfigParser()
    _g_config.read(filename)

    #init default passwdfile
    filename = join(CONFIG_DIR, "passwdfile")
    filename_default = join(dirname(__file__), "conf/passwdfile.default")
    if not isfile(filename):
        if isfile(filename_default):
	    copyfile(filename_default, filename)
        else:
	    raise Exception("Error: passwdfile file '%s' does not exist." % filename)
    
def get_config():
    if not _g_config: 
        init_config()
    return _g_config
