#!/usr/bin/python

#^#
# FileLock.py
#
# as lock object to serialize the access of bsddb.dbshelve
# modify version of http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/519626
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#


import fcntl

class FileLock:
    def __init__(self, filename):
        self.filename = filename

    def acquire(self):
        try:
	    self.file = open(self.filename, "w")
	    fcntl.flock(self.file, fcntl.LOCK_EX | fcntl.LOCK_NB)
	    return True
	except: return False

    def release(self):
	try:
	    fcntl.flock(self.file, fcntl.LOCK_UN)
	    self.file.close()
	except: pass

    def __del__(self):
        self.release()

def main():
    pass

if __name__ == "__main__":
    main()

