#!/usr/bin/env python

#^#
# OVSLog.py
#
# <description>
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

import logging.config
from shutil import copyfile
from os.path import join, isdir, isfile, dirname, isabs
from os import makedirs
from OVSConstants import CONFIG_DIR
from OVSConfig import get_config

def init_log(side="server"):
    filename = join(CONFIG_DIR, "logger_%s.ini" % side)
    filename_default = join(dirname(__file__), "conf/logger_%s.ini.default" % side)
    if not isfile(filename):
        if isfile(filename_default):
            if not isdir(CONFIG_DIR):
                makedirs(CONFIG_DIR)
            copyfile(filename_default, filename)
        else:
            raise Exception("init_log(): error reading config file '%s'!" % filename)
    
    config = get_config()
    logdir = config.get("logger", "log.dir")
    if not isabs(logdir):
        logdir = join(dirname(__file__), logdir)
    if not isdir(logdir):
        makedirs(logdir, 0755)
    defaults = {"log.dir": logdir}
    logging.config.fileConfig(filename, defaults)

