#!/usr/bin/env python
#^#
# OVSRegistrar.py
#
# accept vm mac->ip register broadcast message
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
import sys
import socket
import logging
from OVSConfig import get_config
from OVSCDS import CDS
from OVSCommons import fmt_err_msg

class OVSRegistrar:
    def __init__(self):
	self.s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	self.s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	self.s.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
        config = get_config()
	self.s.bind(('', int(config.get("agent", "port"))))

    def serve(self):	
        logger = logging.getLogger("ovs.macip")
	logger.info("OVSRegistrar: start serving...")
	while True:
	    msg, addr = self.s.recvfrom(8192)
	    logger.info("OVSRegistrar: register message => %s" % msg)
	    cds = CDS("macip")
            try:
                try:
                    for part in msg.split():
                        mac, ip = part.split("=")
                        cds.db_macip[mac.upper()] = ip
                finally:
                    cds.close()
            except: pass
	    #self.s.sendto("success", addr)

def main():
    registrar = OVSRegistrar()
    logger = logging.getLogger("ovs.root")
    try:
	registrar.serve()
    except (KeyboardInterrupt, ), e:
	#CTL-C or pkill -2 -f basename(__file__) to simulate a KeyboadInterrupt
	logger.info("OVSRegistrar:main(): stopped.")
	sys.exit(0)
    except Exception, e:
	logger.error("OVSRegistrar:main(): exception. %s" % fmt_err_msg(e))
	sys.exit(1)

if __name__ == "__main__":
    from OVSLog import init_log
    init_log("client")

    main()

