#!/usr/bin/env python
#^#
# OVSSiteSysAdmin.py
#
# <description>
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

import logging
from OVSServerProxy import ServerProxy
from OVSDB import db_get_srv
from OVSCommons import exposed, fmt_err_msg

@exposed
def shutdown_server(hostname):
    """
    shutdown the specified server

    @return	    "success:<hostname>" if success else "failed:<error message>"
    """
    logger = logging.getLogger("ovs.root")
    try:
	srv = db_get_srv(hostname)
	sp = ServerProxy(srv['agt_url'])
	rs = sp.sys_shutdown()
	if not rs.startswith('success'): raise Exception(rs)
        logger.info("shutdown_server: success. %s => %s" % (hostname, rs))
        return "success:%s" % hostname
    except Exception, e:
	errmsg = fmt_err_msg(e)
	logger.error("shutdown_server: failed. %s => %s" % (hostname, errmsg))
	return "failed:%s" % errmsg

@exposed    
def reboot_server(hostname):
    """
    reboot the specified server

    @return	    "success:<hostname>" if success else "failed:<error message>"
    """
    logger = logging.getLogger("ovs.root")
    try:
	srv = db_get_srv(hostname)
	sp = ServerProxy(srv['agt_url'])
	rs = sp.sys_reboot()
	if not rs.startswith('success'): raise Exception(rs)
        logger.info("reboot_server: success. %s => %s" % (hostname, rs))
        return "success:%s" % hostname
    except Exception, e:
	errmsg = fmt_err_msg(e)
	logger.error("reboot_server: failed. %s => %s" % (hostname, errmsg))
	return "failed:%s" % errmsg 

