#!/usr/bin/env python
#^#
# OVSTimer.py
#
# <description>
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
import time

class Timer:
    def __init__(self, period, interval):
        self.period = period
        self.interval = interval
        self.first = True

    def wait(self):
        if self.first: 
	    self.first = False 
	    return True

        #logging.debug("timer: wait another %ds; %ds to timeout." % (self.interval, self.period,)) 
        self.period -= self.interval
        if self.period <= 0: return False
        time.sleep(self.interval)
        return True

    def timeout(self):
        if self.period <= 0: return True
        return False

