#!/usr/bin/env python
#^#
# broadcast_macip.py
#
# when a vm startup, it broadcast its (mac,ip) for registeration
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, join
import sys
sys.path.append(join(dirname(__file__), ".."))

import time
import os
from socket import socket, AF_INET, SOCK_DGRAM, SOL_SOCKET, SO_BROADCAST 
from OVSConfig import get_config

def get_macip(dev=""):
    stdout = os.popen("/sbin/ifconfig %s" % (dev,))
    d = {}
    block_begin = False
    mac, ip = None, None
    for line in stdout:
	if not line.startswith(" "):
	    block_begin = True
        if "HWaddr" in line:
            mac = line.strip().split()[4]
	    block_begin = False
        if "inet addr:" in line:
            ip = line.strip().split()[1].split(":")[1]
	    if not block_begin:
		d[mac] = ip
    return d

def main():
    s = socket(AF_INET, SOCK_DGRAM)
    s.bind(('', 0))
    s.setsockopt(SOL_SOCKET, SO_BROADCAST, 1)
    
    config = get_config()
    #for i in range(0,3): 
    for i in range(0,1): 
	d = get_macip()
	if not d: return
	data = " ".join(["%s=%s" % (mac, ip) for (mac, ip) in d.items()])
	s.sendto(data, ('<broadcast>', int(config.get("agent", "port"))))
	#(msg, addr) = s.recvfrom(8192)
	#if msg.startswith("success"): break
	time.sleep(1)

if __name__ == "__main__":
    main()
