#!/usr/bin/env python
#^#
# agentcall.py
#
# call a agent throu cmd line, usage:
#	agentcall.py <agent_url> <operation> <argv argv ...>  e.g.
#	agentcall.py http://oracle:orac1e@ovs-y.cn.oracle.com:8899 echo 'hello world!'
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
import xmlrpclib
import socket
import sys

def main():
    agt_url = sys.argv[1]
    func = sys.argv[2]
    args = sys.argv[3:]

    server = xmlrpclib.ServerProxy(agt_url)
    server_func_args = [ 
	##(server, function_name, parameter_list ),
        (server, func, args), 
        ]

    for server, func, args in server_func_args:
        try: 
            print "%s %s" % (func, args)
	    rs = getattr(server, func)(*args)
	    print " => %s" % rs
            if rs.startswith("failed"):
		sys.exit(1)
        except xmlrpclib.Fault, e:
            print e.faultCode, e.faultString
        except xmlrpclib.ProtocolError, e:
            print e #(url, errcode, errmsg, headers)
        except socket.error, (code, msg):
            print "socket error! code=%s, msg=%s" % (code, msg)
        except SystemExit:
	    raise
        except Exception, e:
            print e.__class__, e

if __name__ == "__main__":
    main()

